
explosionGrp = stockScreen:CreateGroup("explosionGrp")
------------------------------------------------------------------------------------------------------------------------------------------------------------
function stockOnExplosionTankEmpty(source)
	parent = source:GetParent()
	if parent:GetChildCount() == 1 then -- If this is the last children of the group...
		parent:Destroy() -- We destroy the group
	else -- Si non, on détruit la source morte
		source:Destroy()
	end
end
------------------------------------------------------------------------------
-- explosionLines Smoke --
model = ParticleModel(3, 5)
model:AddMutableParam("alpha", 0.5, 0)
model:AddMutableRandomParam("size", 0, 1, 1, 3)
model:AddRandomParam("mass", 0.5, 1)
model:AddRandomParam("angle", 0, 2*3.14)

emitter = ParticleEmitter()
emitter:MakeDisk(Vector2D(0, 0), 40)
emitter:SetAngles(3.14 / 2, 0)
emitter:SetDirection(Vector2D(0, -1))

-- Particle
explosionSmoke = explosionGrp:CreateParticleSource("smoke", model, 200)
explosionSmoke:SetEmitter(emitter)
explosionSmoke:SetFlow(-1)
explosionSmoke:SetTank(0)
explosionSmoke:SetForce(5, 40)
explosionSmoke:MakeRenderImages(texSmoke1, Vector2D(70, 70), false)
explosionSmoke:SetGravity(Vector2D(0, -30))
explosionSmoke:SetFriction(0.2)
explosionSmoke.position = Vector2D(0, 0)
explosionSmoke:SetTank(15)
explosionSmoke:SetOnTankEmptyEventFunction(stockOnExplosionTankEmpty)
explosionSmoke:SetZpos(-50)
------------------------------------------------------------------------------
-- explosionLines flames --
model = ParticleModel(0.5, 2)
model:AddMutableParam("alpha", 0.4, 0)
model:AddMutableRandomParam("blue", 0.3, 0.5, 0, 0.1)
model:AddMutableRandomParam("red", 0.8, 1, 0.8, 1)
model:AddMutableRandomParam("green", 0.7, 0.8, 0.5, 0.7)
--model:AddRandomParam("mass", 0.5, 5)
model:AddRandomParam("angle", 0, 2*3.14)
model:AddMutableRandomParam("size", 0.7, 1, 1.5, 2)


emitter = ParticleEmitter()
emitter:MakeDisk(Vector2D(0, 0), 50)
emitter:SetAngles(3.14 * 2, 0)
emitter:SetDirection(Vector2D(0, -1))

-- Particle
explosionFlames = explosionGrp:CreateParticleSource("flames", model, 70)
explosionFlames:SetEmitter(emitter)
explosionFlames:SetFlow(500)
explosionFlames:SetTank(0)
explosionFlames:SetForce(30, 100)
--particleObj:MakeRenderPoints(4)
explosionFlames:MakeRenderImages(texFlame1, Vector2D(50, 50), true)
--explosionFlames:SetGravity(Vector2D(0, 20))
explosionFlames:SetFriction(0.7)
explosionFlames.position = Vector2D(0, 0)
explosionFlames:SetTank(70)
explosionFlames:SetOnTankEmptyEventFunction(stockOnExplosionTankEmpty)
------------------------------------------------------------------------------
-- explosionLines lines
model = ParticleModel(0.3, 0.5)
model:AddMutableParam("alpha", 1, 0)
model:AddMutableRandomParam("blue", 0.2, 0.6, 0, 0.1)
model:AddMutableRandomParam("red", 0.8, 1, 0.7, 1)
model:AddMutableRandomParam("green", 0.8, 1, 0.6, 1)
model:AddRandomParam("mass", 1, 10)

emitter = ParticleEmitter()
emitter:MakeDisk(Vector2D(0, 0), 6)
emitter:SetAngles(3.14 * 2, 0) -- Disk

-- Particle
explosionLines = explosionGrp:CreateParticleSource("lines", model, 20)
explosionLines:SetEmitter(emitter)
explosionLines:SetFlow(-1)
explosionLines:SetTank(0)
explosionLines:SetForce(600, 1200)
explosionLines:MakeRenderLines(0.3, 1.5)
explosionLines:SetGravity(Vector2D(0, 100))
explosionLines:SetFriction(1)
explosionLines.position = Vector2D(0, 0)
explosionLines:SetTank(20)
explosionLines:SetOnTankEmptyEventFunction(stockOnExplosionTankEmpty)
------------------------------------------------------------------------------
-- explosionLines points --
model = ParticleModel(0.5, 1)
model:AddMutableParam("alpha", 1, 0)
model:AddFixedParam("blue", 0.5)
model:AddFixedParam("red", 1)
model:AddFixedParam("green", 1)

emitter = ParticleEmitter()
emitter:MakeDisk(Vector2D(0, 0), 2)
emitter:SetAngles(3.14 * 2, 0)

-- Particle
explosionPoints = explosionGrp:CreateParticleSource("points", model, 50)
explosionPoints:SetEmitter(emitter)
explosionPoints:SetFlow(-1)
explosionPoints:SetTank(0)
explosionPoints:SetForce(200, 400)
explosionPoints:MakeRenderPoints(2)
explosionPoints:SetFriction(0.2)
explosionPoints:SetGravity(Vector2D(0, 30))
explosionPoints.position = Vector2D(0, 0)
explosionPoints:SetTank(50)
explosionPoints:SetOnTankEmptyEventFunction(stockOnExplosionTankEmpty)
------------------------------------------------------------------------------------------------------------------------------------------------------------
function CreateExplosion(position, angle, direction, isBig)
	local clone = explosionGrp:CloneToGroup(gameScreen)
	clone:SetGlobalPosition(position) -- The returned position is a global position
	
	-- We change the angle and direction
	local source = clone:FindByNameParticleSource("flames")
	source:SetEmitterAngle(angle)
	source:SetEmitterDirection(direction)
	if isBig then
		source:SetForce(70, 200)
		source:MakeRenderImages(texFlame1, Vector2D(70, 70), true)
	end
	
	source = clone:FindByNameParticleSource("lines")
	source:SetEmitterAngle(angle)
	source:SetEmitterDirection(direction)
	
	source = clone:FindByNameParticleSource("points")
	source:SetEmitterAngle(angle)
	source:SetEmitterDirection(direction)
	if isBig then
		source:SetForce(300, 600)
	end
end
------------------------------------------------------------------------------------------------------------------------------------------------------------
function CreateSmokeExplosion(position)
	local grp = gameScreen:CreateGroup("smokeExplosion")
	grp:SetGlobalPosition(position)
	explosionSmoke:CloneToGroup(grp)
end
------------------------------------------------------------------------------------------------------------------------------------------------------------
deflagrationGrp = stockScreen:CreateGroup("deflagrationGrp")
------------------------------------------------------------------------------
-- deflaflagration --
model = ParticleModel(2, 2)
model:AddMutableParam("alpha", 1, 0)
model:AddMutableRandomParam("blue", 0.7, 1, 0.5, 1)
model:AddMutableRandomParam("red", 0.3, 0.5, 0.8, 1)
model:AddMutableRandomParam("green", 0.0, 0.3, 0.5, 0.7)
--model:AddRandomParam("mass", 0.5, 5)
--model:AddFixedParam("mass", 1)
--model:AddRandomParam("angle", 0, 2*3.14)
--model:AddMutableRandomParam("size", 0.7, 1, 1.5, 2)


emitter = ParticleEmitter()
emitter:MakePoint(Vector2D(0, 0))
emitter:SetAngles(3.14, 0)
--emitter:SetAngles(0, 0)
emitter:SetDirection(Vector2D(0, -1))

-- Particle
explosion = deflagrationGrp:CreateParticleSource("flames", model, 200)
explosion:SetEmitter(emitter)
explosion:MakeRenderImages(texParticlePoint, Vector2D(200, 200), true)
explosion:SetFlow(30000000)
explosion:SetForce(3000, 3000)
--explosion:SetGravity(Vector2D(0, 0))
--explosion:SetFriction(2)
explosion.position = Vector2D(0, 0)
explosion:SetTank(200)
explosion:SetOnTankEmptyEventFunction(stockOnExplosionTankEmpty)
------------------------------------------------------------------------------
-- explosionLines flames --
--[[model = ParticleModel(0.5, 2)
model:AddMutableParam("alpha", 0.4, 0)
model:AddMutableRandomParam("blue", 0.3, 0.5, 0, 0.1)
model:AddMutableRandomParam("red", 0.8, 1, 0.8, 1)
model:AddMutableRandomParam("green", 0.7, 0.8, 0.5, 0.7)
--model:AddRandomParam("mass", 0.5, 5)
model:AddRandomParam("angle", 0, 2*3.14)
model:AddMutableRandomParam("size", 0.7, 1, 1.5, 2)


emitter = ParticleEmitter()
emitter:MakeDisk(Vector2D(0, 0), 50)
emitter:SetAngles(3.14 * 2, 0)
emitter:SetDirection(Vector2D(0, -1))

-- Particle
explosionFlames = deflagrationGrp:CreateParticleSource("flames", model, 70)
explosionFlames:SetEmitter(emitter)
explosionFlames:SetFlow(500)
explosionFlames:SetTank(0)
explosionFlames:SetForce(30, 100)
--particleObj:MakeRenderPoints(4)
explosionFlames:MakeRenderImages(texFlame1, Vector2D(50, 50), true)
--explosionFlames:SetGravity(Vector2D(0, 20))
explosionFlames:SetFriction(0.7)
explosionFlames.position = Vector2D(0, 0)
explosionFlames:SetTank(70)
explosionFlames:SetOnTankEmptyEventFunction(stockOnExplosionTankEmpty)]]
------------------------------------------------------------
function CreateDeflagration(position)
	local clone = deflagrationGrp:CloneToGroup(gameScreen)
	clone:SetGlobalPosition(position) -- The returned position is a global position
end


------------------------------------------------------------
-- Debris enflamé
------------------------------------------------------------
--[[function debrisChronoFn(ratio, event)
	local grp = event:GetUserData("grp")
	
	grp:FindByNameParticleSource("particle"):SetFlow(event:GetUserData("baseFlow") * (1 - ratio))
	
	if ratio == 1 then
		grp:Destroy()
		event:Destroy()
	end
end


function CreateDebrisBack(parent, position, direction, speed)
	-- Grp
	local grp = parent:CreateGroup("debrisGrp")
	grp:SetSpeed(direction * speed)
	grp:SetPosition(position)

	-- Flame --
	local model = ParticleModel(0.3, 0.5)
	model:AddMutableParam("alpha", 0.7, 0)
	model:AddMutableRandomParam("blue", 0.3, 0.5, 0, 0.1)
	model:AddMutableRandomParam("red", 0.8, 1, 0.7, 1)
	model:AddMutableRandomParam("green", 0.8, 1, 0, 0.2)
	model:AddMutableRandomParam("size", 0.7, 1, 1.5, 2)

	local emitter = ParticleEmitter()
	emitter:MakeDisk(Vector2D(0, 0), 4)
	emitter:SetAngles(3.14 / 4, 0)
	emitter:SetDirection(direction)

	-- Particle
	local particleObj = grp:CreateParticleSource("particle", model, 24)
	particleObj:MakeRenderImages(texParticlePoint, Vector2D(40, 40), true)
	particleObj:SetEmitter(emitter)
	particleObj:SetFlow(48)
	particleObj:SetForce(10, speed)
	particleObj:SetFriction(3)
	particleObj:SetGravity(Vector2D(0, 30))
	particleObj.zPos = -100
	
	-- Event fn
	local event = parent:GetParentScreen():RegisterChronometer(debrisChronoFn, 4, true)
	event:SetUserData("grp", grp)
	event:SetUserData("baseFlow", particleObj:GetFlow())
end]]

function CreateDebris(parent, position, direction, speed)
	local directionNorm = math.sqrt(math.pow(direction.x, 2) + math.pow(direction.y, 2))
	direction = direction / directionNorm

	-- Flame --
	local model = ParticleModel(2, 4)
	model:AddMutableParam("alpha", 0.7, 0)
	model:AddMutableRandomParam("blue", 0.3, 0.5, 0, 0.1)
	model:AddMutableRandomParam("red", 0.8, 1, 0.7, 1)
	model:AddMutableRandomParam("green", 0.8, 1, 0, 0.2)
	model:AddMutableRandomParam("size", 0.5, 1, 2, 2.5)

	local emitter = ParticleEmitter()
	emitter:MakePoint(Vector2D(0, 0))
	emitter:SetAngles(3.14 / 9, 0)
	emitter:SetDirection(direction)

	-- Particle
	local particleObj = parent:CreateParticleSource("particle", model, 15)
	particleObj:MakeRenderImages(texParticlePoint, Vector2D(40, 40), true)
	particleObj:SetEmitter(emitter)
	particleObj:SetFlow(-1)
	particleObj:SetTank(15)
	particleObj:SetForce(speed * 0.7, speed)
	particleObj:SetFriction(0.5)
	particleObj:SetGravity(Vector2D(0, 50))
	particleObj.zPos = -100
	particleObj:SetGlobalPosition(position)
	particleObj:SetAutoDestroy(true)
end
